## aoflagger 2.9.0

=== CMakeLists.txt ===
# AOFlagger 2.8 and higher use 'OBJECT' libraries and the 'TARGET_OBJECTS keywords. These
# require cmake 2.8.8.
cmake_minimum_required(VERSION 2.8.8)

project(AOFlagger)

# Casacore has a separate CMake file in this directory
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/CMake)

find_package(PkgConfig)
pkg_check_modules(GTKMM gtkmm-3.0>=3.0.0)
pkg_check_modules(GLIBMM glibmm-2.4)
pkg_check_modules(SIGCXX sigc++-2.0)

SET(CASACORE_MAKE_REQUIRED_EXTERNALS_OPTIONAL TRUE)
find_package(Casacore REQUIRED COMPONENTS casa ms tables measures)

find_package(CFITSIO REQUIRED)

find_path(FFTW3_INCLUDE_DIR NAMES fftw3.h)

find_library(GSL_LIB NAMES gsl)
find_library(GSL_CBLAS_LIB NAMES gslcblas)
find_path(GSL_INCLUDE_DIR NAMES gsl/gsl_version.h)

find_package(Threads REQUIRED)
find_package(LibXml2 REQUIRED)
find_package(PNG REQUIRED)
#Prevent accidentally finding old BoostConfig.cmake file from casapy
set(Boost_NO_BOOST_CMAKE ON)
find_package(Boost REQUIRED COMPONENTS date_time thread filesystem signals system)
find_package(Threads REQUIRED)
find_library(FFTW3_LIB fftw3 REQUIRED)
enable_language(Fortran OPTIONAL)
find_package(BLAS REQUIRED)
find_package(LAPACK REQUIRED)
if(CMAKE_SYSTEM_NAME MATCHES "Linux")
  find_library(RT_LIBRARY rt)
#  list(APPEND LOFAR_EXTRA_LIBRARIES ${RT_LIBRARY})
endif(CMAKE_SYSTEM_NAME MATCHES "Linux")

include_directories(${CASACORE_INCLUDE_DIRS})
include_directories(${Boost_INCLUDE_DIR})
include_directories(${LIBXML2_INCLUDE_DIR})
include_directories(${CFITSIO_INCLUDE_DIR})
include_directories(${FFTW3_INCLUDE_DIR})
if(GSL_INCLUDE_DIR)
	include_directories(${GSL_INCLUDE_DIR})
endif(GSL_INCLUDE_DIR)

# The following stuff will set the "rpath" correctly, so that
# LD_LIBRARY_PATH doesn't have to be set.

# use, i.e. don't skip the full RPATH for the build tree
SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
# when building, don't use the install RPATH already
# (but later on when installing)
SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 
SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
# the RPATH to be used when installing, but only if it's not a system directory
LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
IF("${isSystemDir}" STREQUAL "-1")
   SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
ENDIF("${isSystemDir}" STREQUAL "-1")

add_subdirectory(src)

install(DIRECTORY data/icons data/applications DESTINATION share )

# add target to generate API documentation with Doxygen
find_package(Doxygen)

if(DOXYGEN_FOUND)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
add_custom_target(doc
	${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
	COMMENT "Generating API documentation with Doxygen" VERBATIM)

endif(DOXYGEN_FOUND)

=== src/CMakeLists.txt ===
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -DNDEBUG -funroll-loops -O3 -std=c++11")

include(CheckCXXCompilerFlag)
include(CheckSymbolExists) 
include(CheckCXXSymbolExists)
include(CheckIncludeFileCXX)

CHECK_CXX_COMPILER_FLAG("-march=native" COMPILER_SUPPORTS_MARCH_NATIVE)
CHECK_CXX_COMPILER_FLAG("-pedantic -Wno-long-long -Werror=vla" COMPILER_SUPPORTS_PEDANTIC)
CHECK_SYMBOL_EXISTS(posix_fallocate "fcntl.h" HAVE_POSIX_FALLOCATE) 
CHECK_CXX_SYMBOL_EXISTS(exp10 "cmath" HAVE_EXP10)

# -march=native speeds up the flagger with about 6% - 7%, but is not supported prior gcc 4.2.
# Hence, only enable it if it is supported.
if(COMPILER_SUPPORTS_MARCH_NATIVE)
	if(NOT PORTABLE)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
	else()
	  message(STATUS "Portable build requested; a generic build will be created with slightly decreased performance")
	endif(NOT PORTABLE)
else()
  message(STATUS " CXX compiler does not support -march=native : your code will not be optimized with -march=native.")
  message(STATUS " This probably means your gcc is old ( < 4.2).")
endif(COMPILER_SUPPORTS_MARCH_NATIVE)

if(COMPILER_SUPPORTS_PEDANTIC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic -Wno-long-long -Werror=vla")
endif(COMPILER_SUPPORTS_PEDANTIC)

if(HAVE_POSIX_FALLOCATE)
  add_definitions(-DHAVE_POSIX_FALLOCATE)
endif(HAVE_POSIX_FALLOCATE)

FIND_PATH(BOOST_ASIO_H_FOUND "boost/asio.hpp")
if(BOOST_ASIO_H_FOUND)
  message(STATUS "Boost ASIO library found.")
else()
  message(STATUS "Boost ASIO library not found, remote access of measurement sets disabled.")
endif(BOOST_ASIO_H_FOUND)

# To enable assembly .s files:
#enable_language(ASM-ATT)

if(GTKMM_FOUND)
  add_definitions(-DHAVE_GTKMM)
endif(GTKMM_FOUND)

if(GSL_LIB AND GSL_CBLAS_LIB AND GSL_INCLUDE_DIR)
  add_definitions(-DHAVE_GSL)
  link_libraries(${GSL_LIB} ${GSL_CBLAS_LIB})
  message(STATUS "GSL found.")
endif(GSL_LIB AND GSL_CBLAS_LIB AND GSL_INCLUDE_DIR)

add_executable(rficonsole rficonsole.cpp)

set(GUI_QUALITY_FILES
  gui/quality/aoqplotwindow.cpp
  gui/quality/baselineplotpage.cpp
  gui/quality/datawindow.cpp
  gui/quality/grayscaleplotpage.cpp
  gui/quality/histogrampage.cpp
  gui/quality/timefrequencyplotpage.cpp
  gui/quality/twodimensionalplotpage.cpp)

set(GUI_PLOT_FILES
  gui/plot/colorscale.cpp
  gui/plot/horizontalplotscale.cpp
  gui/plot/plot2d.cpp
  gui/plot/plotpropertieswindow.cpp
  gui/plot/title.cpp
  gui/plot/verticalplotscale.cpp)

set(GUI_FILES
  gui/controllers/rfiguicontroller.cpp
  gui/complexplaneplotwindow.cpp
  gui/editstrategywindow.cpp
  gui/gotowindow
  gui/highlightwindow.cpp
  gui/imagecomparisonwidget.cpp
  gui/imageplanewindow
  gui/imagepropertieswindow.cpp
  gui/imagewidget.cpp
  gui/msoptionwindow.cpp
  gui/plotframe.cpp
  gui/plotwindow.cpp
  gui/progresswindow.cpp
  gui/rfiguiwindow.cpp
  gui/strategywizardwindow.cpp
  ${GUI_PLOT_FILES} ${GUI_QUALITY_FILES})

set(IMAGING_FILES
  imaging/uvimager.cpp
  imaging/model.cpp)

set(INTERFACE_FILES
  interface/aoflagger.cpp)
  
set(MSIO_FILES
  msio/baselinematrixloader.cpp
  msio/baselinereader.cpp
  msio/directbaselinereader.cpp
  msio/fitsfile.cpp
  msio/indirectbaselinereader.cpp
  msio/memorybaselinereader.cpp
  msio/pngfile.cpp
  msio/rspreader.cpp
  msio/spatialtimeloader.cpp)
  
set(STRUCTURES_FILES
  structures/colormap.cpp
  structures/image2d.cpp
  structures/mask2d.cpp
  structures/measurementset.cpp
  structures/samplerow.cpp
  structures/stokesimager.cpp
  structures/timefrequencydata.cpp)
  
set(QUALITY_FILES
  quality/histogramcollection.cpp
  quality/histogramtablesformatter.cpp
  quality/qualitytablesformatter.cpp
	quality/rayleighfitter.cpp
	quality/statisticscollection.cpp)

set(STRATEGY_ACTION_FILES
  strategy/actions/baselineselectionaction.cpp
  strategy/actions/calibratepassbandaction.cpp
  strategy/actions/changeresolutionaction.cpp
  strategy/actions/foreachbaselineaction.cpp
  strategy/actions/foreachmsaction.cpp
  strategy/actions/frequencyselectionaction.cpp
  strategy/actions/fringestopaction.cpp
	strategy/actions/highpassfilteraction.cpp
  strategy/actions/imageraction.cpp
  strategy/actions/normalizevarianceaction.cpp
  strategy/actions/plotaction.cpp
  strategy/actions/slidingwindowfitaction.cpp
  strategy/actions/spatialcompositionaction.cpp
  strategy/actions/statisticalflagaction.cpp
  strategy/actions/strategy.cpp
  strategy/actions/svdaction.cpp
  strategy/actions/timeconvolutionaction.cpp
  strategy/actions/timeselectionaction.cpp
  strategy/actions/writeflagsaction.cpp)

set(STRATEGY_ALGORITHMS_FILES
  strategy/algorithms/baselineselector.cpp
	strategy/algorithms/baselinetimeplaneimager.cpp
  strategy/algorithms/eigenvalue.cpp
  strategy/algorithms/fringestoppingfitter.cpp
  strategy/algorithms/fringetestcreater.cpp
	strategy/algorithms/highpassfilter.cpp
  strategy/algorithms/localfitmethod.cpp
  strategy/algorithms/mitigationtester.cpp
  strategy/algorithms/morphology.cpp
  strategy/algorithms/rfistatistics.cpp
  strategy/algorithms/sinusfitter.cpp
  strategy/algorithms/statisticalflagger.cpp
  strategy/algorithms/sumthreshold.cpp
  strategy/algorithms/svdmitigater.cpp
  strategy/algorithms/thresholdconfig.cpp
  strategy/algorithms/thresholdmitigater.cpp
  strategy/algorithms/thresholdtools.cpp
  strategy/algorithms/timefrequencystatistics.cpp
  strategy/plots/antennaflagcountplot.cpp
  strategy/plots/frequencyflagcountplot.cpp)

if(GTKMM_FOUND)
set(STRATEGY_PLOTS_FILES
  strategy/plots/frequencypowerplot.cpp
  strategy/plots/iterationsplot.cpp
  strategy/plots/rfiplots.cpp
  strategy/plots/timeflagcountplot.cpp
  util/multiplot.cpp)
else()
 set(STRATEGY_PLOTS_FILES)
endif(GTKMM_FOUND)

set(STRATEGY_CONTROL_FILES
  strategy/control/actionblock.cpp
  strategy/control/actioncontainer.cpp
  strategy/control/actionfactory.cpp
  strategy/control/defaultstrategy.cpp
  strategy/control/strategyreader.cpp
  strategy/control/strategywriter.cpp)

set(STRATEGY_IMAGESETS_FILES
  strategy/imagesets/bhfitsimageset.cpp
  strategy/imagesets/filterbankset.cpp
  strategy/imagesets/fitsimageset.cpp
  strategy/imagesets/imageset.cpp
  strategy/imagesets/msimageset.cpp
  strategy/imagesets/parmimageset.cpp
  strategy/imagesets/pngreader.cpp)

set(STRATEGY_FILES
  ${STRATEGY_ACTION_FILES}
  ${STRATEGY_ALGORITHMS_FILES}
  ${STRATEGY_CONTROL_FILES}
  ${STRATEGY_IMAGESETS_FILES}
  ${STRATEGY_PLOTS_FILES})

set(UTIL_FILES
  util/aologger.cpp
  util/ffttools.cpp
  util/integerdomain.cpp
  util/plot.cpp
  util/rng.cpp
  util/stopwatch.cpp)

if(BOOST_ASIO_H_FOUND AND SIGCXX_FOUND)
	set(REMOTE_FILES
		remote/client.cpp
		remote/server.cpp
		remote/serverconnection.cpp
		remote/processcommander.cpp
		remote/clusteredobservation.cpp
		remote/vdsfile.cpp)
else()
	set(REMOTE_FILES
		remote/clusteredobservation.cpp
		remote/vdsfile.cpp)
endif(BOOST_ASIO_H_FOUND AND SIGCXX_FOUND)

set(ALL_LIBRARIES
	${BLAS_LIBRARIES} ${LAPACK_LIBRARIES}
	${Boost_THREAD_LIBRARY} ${Boost_SYSTEM_LIBRARY}
	${Boost_FILESYSTEM_LIBRARY} ${Boost_DATE_TIME_LIBRARY} ${Boost_SIGNALS_LIBRARY}
	${FFTW3_LIB}
	${CASACORE_LIBRARIES}
	${LAPACK_lapack_LIBRARY}
	${CFITSIO_LIBRARY}
	${CMAKE_THREAD_LIBS_INIT}
	${PNG_LIBRARIES} ${LIBXML2_LIBRARIES}
	${CMAKE_THREAD_LIBS_INIT})

if(GTKMM_FOUND AND GLIBMM_FOUND)
  message(STATUS "GTKMM found.") 
  include_directories(${GTKMM_INCLUDE_DIRS} ${GLIBMM_INCLUDE_DIRS})
  link_directories(${GTKMM_LIBDIR} ${GLIBMM_LIBDIR})
  set(ALL_LIBRARIES ${ALL_LIBRARIES} ${GTKMM_LIBRARIES} ${GLIBMM_LIBRARIES})
endif(GTKMM_FOUND AND GLIBMM_FOUND)

if(SIGCXX_FOUND)
  message(STATUS "SIGCXX found.") 
  include_directories(${SIGCXX_INCLUDE_DIRS})
  link_directories(${SIGCXX_LIBDIR})
  set(ALL_LIBRARIES ${ALL_LIBRARIES} ${SIGCXX_LIBRARIES})
endif(SIGCXX_FOUND)

add_library(aoflagger SHARED ${IMAGING_FILES} ${INTERFACE_FILES} ${MSIO_FILES} ${QUALITY_FILES} ${STRATEGY_FILES} ${STRUCTURES_FILES} ${UTIL_FILES})
SET_TARGET_PROPERTIES(aoflagger PROPERTIES SOVERSION 0)
target_link_libraries(aoflagger ${ALL_LIBRARIES})

link_libraries(aoflagger)

add_library(aoflaggerremote OBJECT ${REMOTE_FILES})
set(AOFLAGGERREMOTE_OBJECT $<TARGET_OBJECTS:aoflaggerremote>)

if(GTKMM_FOUND)
	add_library(aoflaggergui OBJECT ${GUI_FILES})
	set(AOFLAGGERGUI_OBJECT $<TARGET_OBJECTS:aoflaggergui>)
endif(GTKMM_FOUND)

link_libraries(${ALL_LIBRARIES})

add_executable(rfihistory rfihistory.cpp)

if(BOOST_ASIO_H_FOUND AND SIGCXX_FOUND)
  add_executable(aoquality aoquality.cpp ${AOFLAGGERREMOTE_OBJECT})
endif(BOOST_ASIO_H_FOUND AND SIGCXX_FOUND)

if(GTKMM_FOUND)
  add_executable(rfigui rfigui.cpp ${AOFLAGGERGUI_OBJECT} ${AOFLAGGERREMOTE_OBJECT})
  
	if(BOOST_ASIO_H_FOUND AND SIGCXX_FOUND)
		add_executable(aoqplot aoqplot.cpp ${AOFLAGGERGUI_OBJECT} ${AOFLAGGERREMOTE_OBJECT})
		add_executable(badstations badstations.cpp ${AOFLAGGERREMOTE_OBJECT})
		add_executable(aofrequencyfilter aofrequencyfilter.cpp ${AOFLAGGERREMOTE_OBJECT})
	endif(BOOST_ASIO_H_FOUND AND SIGCXX_FOUND)
else()
  message(WARNING " The graphical user interface library GTKMM was not found; rfigui and aoqplot will not be compiled.")
endif(GTKMM_FOUND)

add_executable(aoflagger-bin aoflagger.cpp)
set_target_properties(aoflagger-bin
  PROPERTIES OUTPUT_NAME aoflagger)

add_executable(msinfo msinfo.cpp)

add_executable(colormapper colormapper.cpp)

if(BOOST_ASIO_H_FOUND AND SIGCXX_FOUND AND GTKMM_FOUND)
	add_executable(aoremoteclient aoremoteclient.cpp ${AOFLAGGERREMOTE_OBJECT})
endif(BOOST_ASIO_H_FOUND AND SIGCXX_FOUND AND GTKMM_FOUND)

add_executable(aotest EXCLUDE_FROM_ALL aotest.cpp)
add_test(aotest aotest)
add_custom_target(check COMMAND aotest DEPENDS aotest)

install (TARGETS rficonsole aoflagger-bin DESTINATION bin)
if(GTKMM_FOUND)
	install (TARGETS rfigui aoqplot DESTINATION bin)
endif(GTKMM_FOUND)

if(BOOST_ASIO_H_FOUND AND SIGCXX_FOUND AND GTKMM_FOUND)
	install (TARGETS aoquality aoremoteclient DESTINATION bin)
endif(BOOST_ASIO_H_FOUND AND SIGCXX_FOUND AND GTKMM_FOUND)

install (TARGETS aoflagger DESTINATION lib) 
install (FILES interface/aoflagger.h DESTINATION include)

=== debian/changelog ===
aoflagger (2.9.0-1) unstable; urgency=low

  * New upstream version 2.9.0
  * Rediff patches
  * Mark Arch: any since upstream made it portable now

 -- Ole Streicher <olebole@debian.org>  Wed, 21 Dec 2016 14:54:14 +0100

aoflagger (2.8.0-5) unstable; urgency=medium

  * Enable SSE on i386

 -- Ole Streicher <olebole@debian.org>  Sat, 03 Dec 2016 14:59:52 +0100

aoflagger (2.8.0-4) unstable; urgency=medium

  * Use portable settings to build
  * Sort out shared lib dependencies

 -- Ole Streicher <olebole@debian.org>  Thu, 20 Oct 2016 10:13:53 +0200

aoflagger (2.8.0-3) unstable; urgency=low

  * Use libcfitsio-dev dependency. Closes: #841215

 -- Ole Streicher <olebole@debian.org>  Wed, 19 Oct 2016 09:07:27 +0200

aoflagger (2.8.0-2) unstable; urgency=medium

  * Add static library
  * Limit to x86 architectures. Closes: #840016
  * Make uscan more restrictive to exclude path names in version number

 -- Ole Streicher <olebole@debian.org>  Tue, 18 Oct 2016 15:01:17 +0200

aoflagger (2.8.0-1) unstable; urgency=low

  * Initial release. Closes: #830120

 -- Ole Streicher <olebole@debian.org>  Fri, 30 Sep 2016 09:14:11 +0200

=== debian/control ===
Source: aoflagger
Section: science
Priority: optional
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Gijs Molenaar <gijs@pythonic.nl>, Ole Streicher <olebole@debian.org>
Build-Depends: casacore-dev,
               cmake,
               debhelper (>= 9),
               gfortran,
               libblas-dev,
               libboost-date-time-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-signals-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libcfitsio-dev | libcfitsio3-dev,
               libfftw3-dev,
               libgtkmm-3.0-dev,
               liblapack-dev,
               libpng-dev,
               libxml2-dev,
               zlib1g-dev
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/debian-astro/packages/aoflagger.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-astro/packages/aoflagger.git
Homepage: http://sourceforge.net/projects/aoflagger/

Package: aoflagger
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: aoflagger-dev
Description: Find RFI in radio astronomical observations
 The AOFlagger is a tool that can find and remove radio-frequency interference
 (RFI) in radio astronomical observations. The code has been highly optimized
 for speed and accuracy. It is used by default for the LOFAR radio telescope
 and thus is in productional stage. The software can run in a fully automated
 way, but a graphical interface is provided to analyse results and tweak the
 strategy. The preferred input file format is the Casa Measurement Set (MS)
 format.
 .
 Besides the flagger, the software consists of tools to efficiently visualize
 data in different ways, such as plotting time-frequency diagrams and power
 spectra. It provides the programs aoflagger, rfigui, aoqplot, aoquality and
 more.

Package: libaoflagger0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Find RFI in radio astronomical observations (shared lib)
 The AOFlagger is a tool that can find and remove radio-frequency interference
 (RFI) in radio astronomical observations. The code has been highly optimized
 for speed and accuracy. It is used by default for the LOFAR radio telescope
 and thus is in productional stage. The software can run in a fully automated
 way, but a graphical interface is provided to analyse results and tweak the
 strategy. The preferred input file format is the Casa Measurement Set (MS)
 format.
 .
 This package contains the shared library.

Package: aoflagger-dev
Architecture: any
Section: libdevel
Depends: libaoflagger0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: aoflagger
Description: Find RFI in radio astronomical observations (development files)
 The AOFlagger is a tool that can find and remove radio-frequency interference
 (RFI) in radio astronomical observations. The code has been highly optimized
 for speed and accuracy. It is used by default for the LOFAR radio telescope
 and thus is in productional stage. The software can run in a fully automated
 way, but a graphical interface is provided to analyse results and tweak the
 strategy. The preferred input file format is the Casa Measurement Set (MS)
 format.
 .
 This package contains static library and the header file to compile
 own programs against the library.

=== debian/watch ===
version=3
http://sf.net/aoflagger/aoflagger-(\d[0-9a-zA-Z._]*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## aoflagger 2.10.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,8 +28,7 @@
 find_package(PNG REQUIRED)
 #Prevent accidentally finding old BoostConfig.cmake file from casapy
 set(Boost_NO_BOOST_CMAKE ON)
-find_package(Boost REQUIRED COMPONENTS date_time thread filesystem signals system)
-find_package(Threads REQUIRED)
+find_package(Boost REQUIRED COMPONENTS date_time filesystem python signals system)
 find_library(FFTW3_LIB fftw3 REQUIRED)
 enable_language(Fortran OPTIONAL)
 find_package(BLAS REQUIRED)
@@ -38,6 +37,7 @@
   find_library(RT_LIBRARY rt)
 #  list(APPEND LOFAR_EXTRA_LIBRARIES ${RT_LIBRARY})
 endif(CMAKE_SYSTEM_NAME MATCHES "Linux")
+find_package(PythonLibs 2.7 REQUIRED)
 
 include_directories(${CASACORE_INCLUDE_DIRS})
 include_directories(${Boost_INCLUDE_DIR})
@@ -47,6 +47,7 @@
 if(GSL_INCLUDE_DIR)
 	include_directories(${GSL_INCLUDE_DIR})
 endif(GSL_INCLUDE_DIR)
+include_directories(${PYTHON_INCLUDE_DIRS})
 
 # The following stuff will set the "rpath" correctly, so that
 # LD_LIBRARY_PATH doesn't have to be set.

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,31 +1,31 @@
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -DNDEBUG -funroll-loops -O3 -std=c++11")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Werror=vla -DNDEBUG -funroll-loops -O3 -std=c++11")
 
 include(CheckCXXCompilerFlag)
 include(CheckSymbolExists) 
 include(CheckCXXSymbolExists)
 include(CheckIncludeFileCXX)
 
-CHECK_CXX_COMPILER_FLAG("-march=native" COMPILER_SUPPORTS_MARCH_NATIVE)
-CHECK_CXX_COMPILER_FLAG("-pedantic -Wno-long-long -Werror=vla" COMPILER_SUPPORTS_PEDANTIC)
 CHECK_SYMBOL_EXISTS(posix_fallocate "fcntl.h" HAVE_POSIX_FALLOCATE) 
 CHECK_CXX_SYMBOL_EXISTS(exp10 "cmath" HAVE_EXP10)
 
 # -march=native speeds up the flagger with about 6% - 7%, but is not supported prior gcc 4.2.
 # Hence, only enable it if it is supported.
-if(COMPILER_SUPPORTS_MARCH_NATIVE)
-	if(NOT PORTABLE)
+if(PORTABLE)
+  message(STATUS "Portable build requested; a generic build will be created with slightly decreased performance")
+else()	
+	CHECK_CXX_COMPILER_FLAG("-march=native" COMPILER_SUPPORTS_MARCH_NATIVE)
+	if(COMPILER_SUPPORTS_MARCH_NATIVE)
 		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
 	else()
-	  message(STATUS "Portable build requested; a generic build will be created with slightly decreased performance")
-	endif(NOT PORTABLE)
-else()
-  message(STATUS " CXX compiler does not support -march=native : your code will not be optimized with -march=native.")
-  message(STATUS " This probably means your gcc is old ( < 4.2).")
-endif(COMPILER_SUPPORTS_MARCH_NATIVE)
-
-if(COMPILER_SUPPORTS_PEDANTIC)
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic -Wno-long-long -Werror=vla")
-endif(COMPILER_SUPPORTS_PEDANTIC)
+		message(STATUS " CXX compiler does not support -march=native : your code will not be optimized with -march=native.")
+		message(STATUS " This probably means your compiler is old (e.g. gcc < 4.2).")
+	endif(COMPILER_SUPPORTS_MARCH_NATIVE)
+endif(PORTABLE)
+
+CHECK_CXX_COMPILER_FLAG("-Wsuggest-override" COMPILER_SUPPORTS_SUGGEST_OVERRIDE)
+if(COMPILER_SUPPORTS_SUGGEST_OVERRIDE)
+	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsuggest-override")
+endif(COMPILER_SUPPORTS_SUGGEST_OVERRIDE)
 
 if(HAVE_POSIX_FALLOCATE)
   add_definitions(-DHAVE_POSIX_FALLOCATE)
@@ -53,40 +53,50 @@
 
 add_executable(rficonsole rficonsole.cpp)
 
-set(GUI_QUALITY_FILES
-  gui/quality/aoqplotwindow.cpp
-  gui/quality/baselineplotpage.cpp
-  gui/quality/datawindow.cpp
-  gui/quality/grayscaleplotpage.cpp
-  gui/quality/histogrampage.cpp
-  gui/quality/timefrequencyplotpage.cpp
-  gui/quality/twodimensionalplotpage.cpp)
-
-set(GUI_PLOT_FILES
-  gui/plot/colorscale.cpp
-  gui/plot/horizontalplotscale.cpp
-  gui/plot/plot2d.cpp
-  gui/plot/plotpropertieswindow.cpp
-  gui/plot/title.cpp
-  gui/plot/verticalplotscale.cpp)
+set(AOQPLOT_FILES
+  aoqplot/aoqplotwindow.cpp
+  aoqplot/baselineplotpage.cpp
+  aoqplot/datawindow.cpp
+  aoqplot/grayscaleplotpage.cpp
+  aoqplot/histogrampage.cpp
+  aoqplot/timefrequencyplotpage.cpp
+  aoqplot/twodimensionalplotpage.cpp
+  aoqplot/controllers/aoqplotcontroller.cpp
+  aoqplot/controllers/aoqplotpagecontroller.cpp
+  aoqplot/controllers/baselinepagecontroller.cpp
+  aoqplot/controllers/heatmappagecontroller.cpp
+  aoqplot/controllers/histogrampagecontroller.cpp
+  aoqplot/controllers/tfpagecontroller.cpp)
+
+set(PLOT_FILES
+  plot/colorscale.cpp
+  plot/heatmapplot.cpp
+  plot/horizontalplotscale.cpp
+  plot/plot2d.cpp
+  plot/plotpropertieswindow.cpp
+  plot/title.cpp
+  plot/verticalplotscale.cpp)
 
 set(GUI_FILES
-  gui/controllers/rfiguicontroller.cpp
-  gui/complexplaneplotwindow.cpp
-  gui/editstrategywindow.cpp
-  gui/gotowindow
-  gui/highlightwindow.cpp
-  gui/imagecomparisonwidget.cpp
-  gui/imageplanewindow
-  gui/imagepropertieswindow.cpp
-  gui/imagewidget.cpp
-  gui/msoptionwindow.cpp
-  gui/plotframe.cpp
-  gui/plotwindow.cpp
-  gui/progresswindow.cpp
-  gui/rfiguiwindow.cpp
-  gui/strategywizardwindow.cpp
-  ${GUI_PLOT_FILES} ${GUI_QUALITY_FILES})
+  rfigui/controllers/imagecomparisoncontroller.cpp
+  rfigui/controllers/rfiguicontroller.cpp
+  rfigui/complexplaneplotwindow.cpp
+  rfigui/editstrategywindow.cpp
+  rfigui/gotowindow
+  rfigui/highlightwindow.cpp
+  rfigui/imagecomparisonwidget.cpp
+  rfigui/imageplanewindow
+  rfigui/imagepropertieswindow.cpp
+  rfigui/heatmapwidget.cpp
+  rfigui/msoptionwindow.cpp
+  rfigui/plotframe.cpp
+  rfigui/plotwindow.cpp
+  rfigui/progresswindow.cpp
+  rfigui/rfiguiwindow.cpp
+  rfigui/strategywizardwindow.cpp
+  strategy/plots/rfiplots.cpp
+  util/multiplot.cpp
+  ${PLOT_FILES} ${AOQPLOT_FILES})
 
 set(IMAGING_FILES
   imaging/uvimager.cpp
@@ -134,8 +144,8 @@
   strategy/actions/imageraction.cpp
   strategy/actions/normalizevarianceaction.cpp
   strategy/actions/plotaction.cpp
+  strategy/actions/saveheatmapaction.cpp
   strategy/actions/slidingwindowfitaction.cpp
-  strategy/actions/spatialcompositionaction.cpp
   strategy/actions/statisticalflagaction.cpp
   strategy/actions/strategy.cpp
   strategy/actions/svdaction.cpp
@@ -146,41 +156,36 @@
 set(STRATEGY_ALGORITHMS_FILES
   strategy/algorithms/baselineselector.cpp
 	strategy/algorithms/baselinetimeplaneimager.cpp
+  strategy/algorithms/combinatorialthresholder.cpp
   strategy/algorithms/eigenvalue.cpp
   strategy/algorithms/fringestoppingfitter.cpp
   strategy/algorithms/fringetestcreater.cpp
 	strategy/algorithms/highpassfilter.cpp
   strategy/algorithms/localfitmethod.cpp
-  strategy/algorithms/mitigationtester.cpp
   strategy/algorithms/morphology.cpp
-  strategy/algorithms/rfistatistics.cpp
   strategy/algorithms/sinusfitter.cpp
   strategy/algorithms/statisticalflagger.cpp
   strategy/algorithms/sumthreshold.cpp
   strategy/algorithms/svdmitigater.cpp
+  strategy/algorithms/testsetgenerator.cpp
   strategy/algorithms/thresholdconfig.cpp
-  strategy/algorithms/thresholdmitigater.cpp
   strategy/algorithms/thresholdtools.cpp
   strategy/algorithms/timefrequencystatistics.cpp
   strategy/plots/antennaflagcountplot.cpp
   strategy/plots/frequencyflagcountplot.cpp)
 
-if(GTKMM_FOUND)
 set(STRATEGY_PLOTS_FILES
   strategy/plots/frequencypowerplot.cpp
   strategy/plots/iterationsplot.cpp
-  strategy/plots/rfiplots.cpp
-  strategy/plots/timeflagcountplot.cpp
-  util/multiplot.cpp)
-else()
- set(STRATEGY_PLOTS_FILES)
-endif(GTKMM_FOUND)
+  strategy/plots/timeflagcountplot.cpp)
 
 set(STRATEGY_CONTROL_FILES
   strategy/control/actionblock.cpp
   strategy/control/actioncontainer.cpp
   strategy/control/actionfactory.cpp
+  strategy/control/artifactset.cpp
   strategy/control/defaultstrategy.cpp
+  strategy/control/pythonstrategy.cpp
   strategy/control/strategyreader.cpp
   strategy/control/strategywriter.cpp)
 
@@ -201,7 +206,7 @@
   ${STRATEGY_PLOTS_FILES})
 
 set(UTIL_FILES
-  util/aologger.cpp
+  util/logger.cpp
   util/ffttools.cpp
   util/integerdomain.cpp
   util/plot.cpp
@@ -222,24 +227,25 @@
 		remote/vdsfile.cpp)
 endif(BOOST_ASIO_H_FOUND AND SIGCXX_FOUND)
 
+set(PYTHON_FILES
+	python/functions.cpp)
+
 set(ALL_LIBRARIES
 	${BLAS_LIBRARIES} ${LAPACK_LIBRARIES}
-	${Boost_THREAD_LIBRARY} ${Boost_SYSTEM_LIBRARY}
-	${Boost_FILESYSTEM_LIBRARY} ${Boost_DATE_TIME_LIBRARY} ${Boost_SIGNALS_LIBRARY}
+	${Boost_SYSTEM_LIBRARY}
+	${Boost_FILESYSTEM_LIBRARY} ${Boost_DATE_TIME_LIBRARY} ${Boost_PYTHON_LIBRARIES} ${Boost_SIGNALS_LIBRARY}
 	${FFTW3_LIB}
 	${CASACORE_LIBRARIES}
 	${LAPACK_lapack_LIBRARY}
 	${CFITSIO_LIBRARY}
 	${CMAKE_THREAD_LIBS_INIT}
 	${PNG_LIBRARIES} ${LIBXML2_LIBRARIES}
-	${CMAKE_THREAD_LIBS_INIT})
-
-if(GTKMM_FOUND AND GLIBMM_FOUND)
-  message(STATUS "GTKMM found.") 
-  include_directories(${GTKMM_INCLUDE_DIRS} ${GLIBMM_INCLUDE_DIRS})
-  link_directories(${GTKMM_LIBDIR} ${GLIBMM_LIBDIR})
-  set(ALL_LIBRARIES ${ALL_LIBRARIES} ${GTKMM_LIBRARIES} ${GLIBMM_LIBRARIES})
-endif(GTKMM_FOUND AND GLIBMM_FOUND)
+	${PYTHON_LIBRARY})
+
+message(STATUS "GTKMM found.") 
+include_directories(${GTKMM_INCLUDE_DIRS} ${GLIBMM_INCLUDE_DIRS})
+link_directories(${GTKMM_LIBDIR} ${GLIBMM_LIBDIR})
+set(ALL_LIBRARIES ${ALL_LIBRARIES} ${GTKMM_LIBRARIES} ${GLIBMM_LIBRARIES})
 
 if(SIGCXX_FOUND)
   message(STATUS "SIGCXX found.") 
@@ -248,11 +254,20 @@
   set(ALL_LIBRARIES ${ALL_LIBRARIES} ${SIGCXX_LIBRARIES})
 endif(SIGCXX_FOUND)
 
-add_library(aoflagger SHARED ${IMAGING_FILES} ${INTERFACE_FILES} ${MSIO_FILES} ${QUALITY_FILES} ${STRATEGY_FILES} ${STRUCTURES_FILES} ${UTIL_FILES})
-SET_TARGET_PROPERTIES(aoflagger PROPERTIES SOVERSION 0)
+if(GTKMM_FOUND)
+	set(AOFLAGGER_PLOT_FILES ${PLOT_FILES})
+endif(GTKMM_FOUND)
+add_library(aoflagger SHARED ${AOFLAGGER_PLOT_FILES} ${IMAGING_FILES} ${INTERFACE_FILES} ${MSIO_FILES} ${QUALITY_FILES} ${STRATEGY_FILES} ${STRUCTURES_FILES} ${UTIL_FILES} ${PYTHON_FILES})
+set_target_properties(aoflagger PROPERTIES SOVERSION 0)
 target_link_libraries(aoflagger ${ALL_LIBRARIES})
 
 link_libraries(aoflagger)
+
+add_library(python_aoflagger SHARED python/pyinterface.cpp)
+set_target_properties(python_aoflagger PROPERTIES SOVERSION 0)
+set_target_properties(python_aoflagger PROPERTIES OUTPUT_NAME "aoflagger")
+set_target_properties(python_aoflagger PROPERTIES PREFIX "")
+target_link_libraries(python_aoflagger ${ALL_LIBRARIES} )
 
 add_library(aoflaggerremote OBJECT ${REMOTE_FILES})
 set(AOFLAGGERREMOTE_OBJECT $<TARGET_OBJECTS:aoflaggerremote>)

=== debian/changelog ===
aoflagger (2.10.0-2) unstable; urgency=low

  [ Gijs Molenaar ]
  * Add pow10 patch. Closes: #893272

 -- Ole Streicher <olebole@debian.org>  Mon, 19 Mar 2018 15:08:04 +0100

aoflagger (2.10.0-1) unstable; urgency=low

  * New upstream version 2.10.0. Rediff patches
  * Update VCS fields to use salsa.d.o
  * Push Standards-Version to 4.1.3. Change remaining URLs to https

 -- Ole Streicher <olebole@debian.org>  Mon, 19 Feb 2018 21:31:49 +0100

=== debian/control ===
--- 
+++ 
@@ -5,12 +5,15 @@
 Uploaders: Gijs Molenaar <gijs@pythonic.nl>, Ole Streicher <olebole@debian.org>
 Build-Depends: casacore-dev,
                cmake,
-               debhelper (>= 9),
+               debhelper (>= 11),
+               doxygen,
                gfortran,
+               graphviz,
                libblas-dev,
                libboost-date-time-dev,
                libboost-dev,
                libboost-filesystem-dev,
+               libboost-python-dev,
                libboost-signals-dev,
                libboost-system-dev,
                libboost-thread-dev,
@@ -19,12 +22,13 @@
                libgtkmm-3.0-dev,
                liblapack-dev,
                libpng-dev,
+               libpython-dev,
                libxml2-dev,
                zlib1g-dev
-Standards-Version: 3.9.8
-Vcs-Git: https://anonscm.debian.org/git/debian-astro/packages/aoflagger.git
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-astro/packages/aoflagger.git
-Homepage: http://sourceforge.net/projects/aoflagger/
+Standards-Version: 4.1.3
+Vcs-Git: https://salsa.debian.org/debian-astro-team/aoflagger.git
+Vcs-Browser: https://salsa.debian.org/debian-astro-team/aoflagger
+Homepage: https://sourceforge.net/projects/aoflagger/
 
 Package: aoflagger
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

ifeq ($(DEB_HOST_ARCH_CPU),i386)
    export DEB_CXXFLAGS_MAINT_APPEND = -msse -msse2 -mfpmath=sse
endif

CMAKE_FLAGS += -DDEB_BUILD_MULTIARCH=`dpkg-architecture -qDEB_BUILD_MULTIARCH` -DPORTABLE=yes

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

=== debian/watch ===
version=3
https://sf.net/aoflagger/aoflagger-(\d[0-9a-zA-Z._]*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## aoflagger 2.11.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 # -march=native speeds up the flagger with about 6% - 7%, but is not supported prior gcc 4.2.
 # Hence, only enable it if it is supported.
 if(PORTABLE)
-  message(STATUS "Portable build requested; a generic build will be created with slightly decreased performance")
+  message(STATUS "Portable build requested; a generic build will be created with slightly decreased performance.")
 else()	
 	CHECK_CXX_COMPILER_FLAG("-march=native" COMPILER_SUPPORTS_MARCH_NATIVE)
 	if(COMPILER_SUPPORTS_MARCH_NATIVE)
@@ -154,6 +154,7 @@
   strategy/actions/writeflagsaction.cpp)
 
 set(STRATEGY_ALGORITHMS_FILES
+  strategy/algorithms/antennaselector.cpp
   strategy/algorithms/baselineselector.cpp
 	strategy/algorithms/baselinetimeplaneimager.cpp
   strategy/algorithms/combinatorialthresholder.cpp
@@ -233,25 +234,30 @@
 set(ALL_LIBRARIES
 	${BLAS_LIBRARIES} ${LAPACK_LIBRARIES}
 	${Boost_SYSTEM_LIBRARY}
-	${Boost_FILESYSTEM_LIBRARY} ${Boost_DATE_TIME_LIBRARY} ${Boost_PYTHON_LIBRARIES} ${Boost_SIGNALS_LIBRARY}
+	${Boost_FILESYSTEM_LIBRARY} ${Boost_DATE_TIME_LIBRARY}
+#	${Boost_PYTHON-PY36_LIBRARIES}
+	${Boost_PYTHON_LIBRARIES}
+	${Boost_SIGNALS_LIBRARY}
 	${FFTW3_LIB}
 	${CASACORE_LIBRARIES}
 	${LAPACK_lapack_LIBRARY}
 	${CFITSIO_LIBRARY}
 	${CMAKE_THREAD_LIBS_INIT}
 	${PNG_LIBRARIES} ${LIBXML2_LIBRARIES}
-	${PYTHON_LIBRARY})
-
-message(STATUS "GTKMM found.") 
-include_directories(${GTKMM_INCLUDE_DIRS} ${GLIBMM_INCLUDE_DIRS})
-link_directories(${GTKMM_LIBDIR} ${GLIBMM_LIBDIR})
-set(ALL_LIBRARIES ${ALL_LIBRARIES} ${GTKMM_LIBRARIES} ${GLIBMM_LIBRARIES})
+	${PYTHON_LIBRARIES})
+
+if(GTKMM_FOUND)
+	message(STATUS "GTKMM found.") 
+	include_directories(${GTKMM_INCLUDE_DIRS})
+	link_directories(${GTKMM_LIBDIR})
+	set(ALL_LIBRARIES ${ALL_LIBRARIES} ${GTKMM_LIBRARIES})
+endif(GTKMM_FOUND)
 
 if(SIGCXX_FOUND)
-  message(STATUS "SIGCXX found.") 
-  include_directories(${SIGCXX_INCLUDE_DIRS})
-  link_directories(${SIGCXX_LIBDIR})
-  set(ALL_LIBRARIES ${ALL_LIBRARIES} ${SIGCXX_LIBRARIES})
+	message(STATUS "SIGCXX found.") 
+	include_directories(${SIGCXX_INCLUDE_DIRS})
+	link_directories(${SIGCXX_LIBDIR})
+	set(ALL_LIBRARIES ${ALL_LIBRARIES} ${SIGCXX_LIBRARIES})
 endif(SIGCXX_FOUND)
 
 if(GTKMM_FOUND)

=== debian/changelog ===
aoflagger (2.11.0-1build1) cosmic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2018 12:52:51 +0000

aoflagger (2.11.0-1) unstable; urgency=low

  * New upstream version 2.11.0. Rediff patches
  * Remove unused paragraph from d/copyright

 -- Ole Streicher <olebole@debian.org>  Wed, 13 Jun 2018 11:12:52 +0200

aoflagger (2.10.0-3) unstable; urgency=medium

  * Remove outdated CheckCXXSymbolExists (Closes: #897115)
  * Push Standards-Version to 4.1.4. No changes needed.
  * Remove unneeded --parallel from d/rules
  * Mark aoflagger-dev as Multi-Arch: same as hinted

 -- Ole Streicher <olebole@debian.org>  Sat, 28 Apr 2018 21:41:14 +0200

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,7 @@
 CMAKE_FLAGS += -DDEB_BUILD_MULTIARCH=`dpkg-architecture -qDEB_BUILD_MULTIARCH` -DPORTABLE=yes
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- $(CMAKE_FLAGS)

## aoflagger 2.12.1

=== debian/changelog ===
aoflagger (2.12.1-2) unstable; urgency=medium

  * Use float-store=true instead of SSE on i386 (Closes: #908384)

 -- Ole Streicher <olebole@debian.org>  Mon, 10 Sep 2018 10:55:18 +0200

aoflagger (2.12.1-1) unstable; urgency=medium

  * New upstream version 2.12.1. Closes: #908008
  * Rediff patches

 -- Ole Streicher <olebole@debian.org>  Wed, 05 Sep 2018 20:47:06 +0200

aoflagger (2.12.0-1) unstable; urgency=medium

  * New upstream version 2.12.0. Rediff patches
  * Push Standards-Version to 4.2.1. Change remaining URLs to https

 -- Ole Streicher <olebole@debian.org>  Tue, 04 Sep 2018 17:44:57 +0200

## aoflagger 2.13.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,6 @@
 
 find_package(PkgConfig)
 pkg_check_modules(GTKMM gtkmm-3.0>=3.0.0)
-pkg_check_modules(GLIBMM glibmm-2.4)
 pkg_check_modules(SIGCXX sigc++-2.0)
 
 SET(CASACORE_MAKE_REQUIRED_EXTERNALS_OPTIONAL TRUE)
@@ -28,7 +27,14 @@
 find_package(PNG REQUIRED)
 #Prevent accidentally finding old BoostConfig.cmake file from casapy
 set(Boost_NO_BOOST_CMAKE ON)
+#set(PY_VERSION 3)
+#find_package(PythonLibs ${PY_VERSION} REQUIRED)
+find_package(PythonInterp REQUIRED)
+#find_package(PythonLibs ${PYTHON_VERSION_STRING} REQUIRED)
+find_package(PythonLibs 2.7 REQUIRED)
+#message(STATUS "Using python version ${PYTHON_VERSION_STRING}")
 find_package(Boost REQUIRED COMPONENTS date_time filesystem python signals system)
+#find_package(Boost REQUIRED COMPONENTS date_time filesystem python-py36 signals system)
 find_library(FFTW3_LIB fftw3 REQUIRED)
 enable_language(Fortran OPTIONAL)
 find_package(BLAS REQUIRED)
@@ -37,7 +43,6 @@
   find_library(RT_LIBRARY rt)
 #  list(APPEND LOFAR_EXTRA_LIBRARIES ${RT_LIBRARY})
 endif(CMAKE_SYSTEM_NAME MATCHES "Linux")
-find_package(PythonLibs 2.7 REQUIRED)
 
 include_directories(${CASACORE_INCLUDE_DIRS})
 include_directories(${Boost_INCLUDE_DIR})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -50,8 +50,6 @@
   link_libraries(${GSL_LIB} ${GSL_CBLAS_LIB})
   message(STATUS "GSL found.")
 endif(GSL_LIB AND GSL_CBLAS_LIB AND GSL_INCLUDE_DIR)
-
-add_executable(rficonsole rficonsole.cpp)
 
 set(AOQPLOT_FILES
   aoqplot/aoqplotwindow.cpp
@@ -72,6 +70,7 @@
   plot/colorscale.cpp
   plot/heatmapplot.cpp
   plot/horizontalplotscale.cpp
+  plot/legend.cpp
   plot/plot2d.cpp
   plot/plotpropertieswindow.cpp
   plot/title.cpp
@@ -84,7 +83,6 @@
   rfigui/editstrategywindow.cpp
   rfigui/gotowindow
   rfigui/highlightwindow.cpp
-  rfigui/imagecomparisonwidget.cpp
   rfigui/imageplanewindow
   rfigui/imagepropertieswindow.cpp
   rfigui/heatmapwidget.cpp
@@ -146,11 +144,12 @@
   strategy/actions/plotaction.cpp
   strategy/actions/saveheatmapaction.cpp
   strategy/actions/slidingwindowfitaction.cpp
-  strategy/actions/statisticalflagaction.cpp
+  strategy/actions/morphologicalflagaction.cpp
   strategy/actions/strategy.cpp
   strategy/actions/svdaction.cpp
   strategy/actions/timeconvolutionaction.cpp
   strategy/actions/timeselectionaction.cpp
+  strategy/actions/visualizeaction.cpp
   strategy/actions/writeflagsaction.cpp)
 
 set(STRATEGY_ALGORITHMS_FILES
@@ -165,8 +164,9 @@
   strategy/algorithms/localfitmethod.cpp
   strategy/algorithms/morphology.cpp
   strategy/algorithms/sinusfitter.cpp
-  strategy/algorithms/statisticalflagger.cpp
+  strategy/algorithms/morphologicalflagger.cpp
   strategy/algorithms/sumthreshold.cpp
+  strategy/algorithms/sumthresholdmissing.cpp
   strategy/algorithms/svdmitigater.cpp
   strategy/algorithms/testsetgenerator.cpp
   strategy/algorithms/thresholdconfig.cpp
@@ -304,8 +304,7 @@
 endif(GTKMM_FOUND)
 
 add_executable(aoflagger-bin aoflagger.cpp)
-set_target_properties(aoflagger-bin
-  PROPERTIES OUTPUT_NAME aoflagger)
+set_target_properties(aoflagger-bin PROPERTIES OUTPUT_NAME aoflagger)
 
 add_executable(msinfo msinfo.cpp)
 
@@ -319,7 +318,7 @@
 add_test(aotest aotest)
 add_custom_target(check COMMAND aotest DEPENDS aotest)
 
-install (TARGETS rficonsole aoflagger-bin DESTINATION bin)
+# Installation commands
 if(GTKMM_FOUND)
 	install (TARGETS rfigui aoqplot DESTINATION bin)
 endif(GTKMM_FOUND)
@@ -328,5 +327,6 @@
 	install (TARGETS aoquality aoremoteclient DESTINATION bin)
 endif(BOOST_ASIO_H_FOUND AND SIGCXX_FOUND AND GTKMM_FOUND)
 
+install (TARGETS aoflagger-bin DESTINATION bin)
 install (TARGETS aoflagger DESTINATION lib) 
 install (FILES interface/aoflagger.h DESTINATION include)

=== debian/changelog ===
aoflagger (2.13.0-1) unstable; urgency=low

  * New upstream version 2.13.0

 -- Ole Streicher <olebole@debian.org>  Thu, 08 Nov 2018 13:31:16 +0100

=== debian/control ===
--- 
+++ 
@@ -25,7 +25,7 @@
                libpython-dev,
                libxml2-dev,
                zlib1g-dev
-Standards-Version: 4.1.3
+Standards-Version: 4.2.1
 Vcs-Git: https://salsa.debian.org/debian-astro-team/aoflagger.git
 Vcs-Browser: https://salsa.debian.org/debian-astro-team/aoflagger
 Homepage: https://sourceforge.net/projects/aoflagger/
@@ -66,6 +66,7 @@
 
 Package: aoflagger-dev
 Architecture: any
+Multi-Arch: same
 Section: libdevel
 Depends: libaoflagger0 (= ${binary:Version}),
          ${misc:Depends},

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 #export DH_VERBOSE=1
 
 ifeq ($(DEB_HOST_ARCH_CPU),i386)
-    export DEB_CXXFLAGS_MAINT_APPEND = -msse -msse2 -mfpmath=sse
+    export DEB_CXXFLAGS_MAINT_APPEND = -ffloat-store
 endif
 
 CMAKE_FLAGS += -DDEB_BUILD_MULTIARCH=`dpkg-architecture -qDEB_BUILD_MULTIARCH` -DPORTABLE=yes

## aoflagger 2.14.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -33,8 +33,9 @@
 #find_package(PythonLibs ${PYTHON_VERSION_STRING} REQUIRED)
 find_package(PythonLibs 2.7 REQUIRED)
 #message(STATUS "Using python version ${PYTHON_VERSION_STRING}")
-find_package(Boost REQUIRED COMPONENTS date_time filesystem python signals system)
-#find_package(Boost REQUIRED COMPONENTS date_time filesystem python-py36 signals system)
+# At least the intrusive_ref_counter needs Boost 1.55 (because the header was moved)
+find_package(Boost 1.55.0 REQUIRED COMPONENTS date_time filesystem python system)
+#find_package(Boost REQUIRED COMPONENTS date_time filesystem python-py36 system)
 find_library(FFTW3_LIB fftw3 REQUIRED)
 enable_language(Fortran OPTIONAL)
 find_package(BLAS REQUIRED)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -112,6 +112,7 @@
   msio/memorybaselinereader.cpp
   msio/pngfile.cpp
   msio/rspreader.cpp
+  msio/singlebaselinefile.cpp
   msio/spatialtimeloader.cpp)
   
 set(STRUCTURES_FILES
@@ -132,7 +133,7 @@
 
 set(STRATEGY_ACTION_FILES
   strategy/actions/baselineselectionaction.cpp
-  strategy/actions/calibratepassbandaction.cpp
+  strategy/actions/calibratebandpassaction.cpp
   strategy/actions/changeresolutionaction.cpp
   strategy/actions/foreachbaselineaction.cpp
   strategy/actions/foreachmsaction.cpp
@@ -197,7 +198,8 @@
   strategy/imagesets/imageset.cpp
   strategy/imagesets/msimageset.cpp
   strategy/imagesets/parmimageset.cpp
-  strategy/imagesets/pngreader.cpp)
+  strategy/imagesets/pngreader.cpp
+  strategy/imagesets/rfibaselineset.cpp)
 
 set(STRATEGY_FILES
   ${STRATEGY_ACTION_FILES}
@@ -237,7 +239,6 @@
 	${Boost_FILESYSTEM_LIBRARY} ${Boost_DATE_TIME_LIBRARY}
 #	${Boost_PYTHON-PY36_LIBRARIES}
 	${Boost_PYTHON_LIBRARIES}
-	${Boost_SIGNALS_LIBRARY}
 	${FFTW3_LIB}
 	${CASACORE_LIBRARIES}
 	${LAPACK_lapack_LIBRARY}

=== debian/changelog ===
aoflagger (2.14.0-2ubuntu2) focal; urgency=medium

  * Fix up boost numpy/python detection.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 06 Feb 2020 13:31:36 +0000

aoflagger (2.14.0-2ubuntu1) focal; urgency=medium

  * Drop unused boost-signals dependency, package is ported to signals2.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 06 Feb 2020 12:58:21 +0000

aoflagger (2.14.0-2build3) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 19:52:26 +0000

aoflagger (2.14.0-2build2) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 06:01:31 +0000

aoflagger (2.14.0-2build1) focal; urgency=medium

  * No-change upload for casacore soname changes.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 18 Jan 2020 14:00:35 +0000

aoflagger (2.14.0-2) unstable; urgency=low

  * Switch to Python 3. (Closes: #936122)

 -- Ole Streicher <olebole@debian.org>  Fri, 30 Aug 2019 13:45:18 +0200

aoflagger (2.14.0-1) unstable; urgency=low

  * New upstream version 2.14.0. Rediff patches
  * Push Standards-Version to 4.4.0. No changes required.
  * Push compat to 12; switch to debhelper-compat

 -- Ole Streicher <olebole@debian.org>  Thu, 25 Jul 2019 00:50:27 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: aoflagger
 Section: science
 Priority: optional
-Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
 Uploaders: Gijs Molenaar <gijs@pythonic.nl>, Ole Streicher <olebole@debian.org>
 Build-Depends: casacore-dev,
                cmake,
-               debhelper (>= 11),
+               debhelper-compat (= 12),
                doxygen,
                gfortran,
                graphviz,
@@ -13,19 +14,19 @@
                libboost-date-time-dev,
                libboost-dev,
                libboost-filesystem-dev,
+               libboost-numpy-dev,
                libboost-python-dev,
-               libboost-signals-dev,
                libboost-system-dev,
                libboost-thread-dev,
-               libcfitsio-dev | libcfitsio3-dev,
+               libcfitsio-dev,
                libfftw3-dev,
                libgtkmm-3.0-dev,
                liblapack-dev,
                libpng-dev,
-               libpython-dev,
+               libpython3-dev,
                libxml2-dev,
                zlib1g-dev
-Standards-Version: 4.2.1
+Standards-Version: 4.4.0
 Vcs-Git: https://salsa.debian.org/debian-astro-team/aoflagger.git
 Vcs-Browser: https://salsa.debian.org/debian-astro-team/aoflagger
 Homepage: https://sourceforge.net/projects/aoflagger/
